<script setup lang="ts">
import { onMounted } from 'vue'
import { useStockTakingStore } from '../store/stockTaking'
import { useInventoryStore } from '../store/inventory'
import WarningDialog from '../components/WarningDialog.vue'
import { getDateNowString } from '@/utils/constants'
import { useAuthStore } from '@/views/Authentication/stores/auth'
const inventory = useInventoryStore()
const stock = useStockTakingStore()
const auth = useAuthStore()

onMounted(() => {
  stock.fetchIngredient()
})

function handleHighlight(min: number, bal: number) {
  if (inventory.isLowStock(min, bal)) {
    return 'd-flex text-warning'
  }
  return 'd-flex'
}
</script>

<template>
  <v-dialog v-model="stock.isDialogOpen" fullscreen persistent transition="dialog-top-transition">
    <v-card class="px-10 py-2">
      <template #title>
        <v-row>
          <v-col>
            <h3>Stock-taking</h3>
            <h4>Inventory of branch : {{ inventory.selectedInventory?.branch?.name }}</h4>
          </v-col>
          <v-spacer></v-spacer>
          <v-col>
            <h3>Employee : {{ auth.getCurrentUser()?.email }}</h3>
            <h4>
              {{ `Current date: ${getDateNowString()}` }}
            </h4>
          </v-col>
        </v-row>
        <v-divider class="mt-5" thickness="2"></v-divider>
      </template>
      <v-data-table
        class="px-6"
        :items="stock.inventoryItems"
        :headers="stock.headers"
        height="500"
        fixed-header
        :items-per-page="0"
        no-data-text="No items"
      >
        <template #item="{ item, index }">
          <tr>
            <td>
              <v-select
                class="d-flex"
                :items="inventory.availableIngredient"
                :item-title="'name'"
                return-object
                v-model:model-value="item.ingredient"
                variant="outlined"
              ></v-select>
            </td>
            <td>
              <v-text-field
                name="minAmount"
                class="d-flex"
                v-model.number="item.minBalance"
                variant="outlined"
                type="number"
              ></v-text-field>
            </td>
            <td>
              <v-text-field
                name="balance"
                :class="handleHighlight(item.minBalance, item.balance)"
                v-model.number="item.balance"
                variant="outlined"
                type="number"
              ></v-text-field>
            </td>
            <td>{{ item.ingredient?.unit }}</td>
            <td>
              <v-text-field
                name="totalNetValue"
                v-model.number="item.value"
                variant="outlined"
                type="number"
              ></v-text-field>
            </td>
            <td>
              <v-btn variant="plain" icon="mdi-delete" @click="stock.removeItem(index)"></v-btn>
            </td>
          </tr>
        </template>

        <template #bottom>
          <v-divider thickness="2"></v-divider>
          <v-row no-gutters class="justify-center mt-3">
            <v-col>
              {{ `Total value : ${stock.getTotalNetValue} ฿` }}
            </v-col>
            <v-col>
              <v-btn text="add" prepend-icon="mdi-plus" variant="tonal" @click="stock.addItem()">
              </v-btn>
            </v-col>
          </v-row>
        </template>
      </v-data-table>
      <v-spacer></v-spacer>
      <v-card-actions class="justify-end ma-2">
        <v-btn variant="outlined" @click="stock.closeDialog()"> close </v-btn>
        <WarningDialog :save-callback="stock.save">
          <template #activator="{ props }">
            <v-btn variant="tonal" v-bind="props"> save </v-btn>
          </template>
        </WarningDialog>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
